package rs.telenor.main;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

import rs.telenor.model.Customer;
import rs.telenor.model.Department;
import rs.telenor.model.Employee;
import rs.telenor.model.Product;
import rs.telenor.model.ProductType;
import rs.telenor.model.SubscriptionType;
import rs.telenor.model.Timer;
import rs.telenor.util.RuleListener;

public class TelenorApplication {
	
	public static void main(String[] args) throws ParseException {
		KieServices ks = KieServices.Factory.get();
		KieContainer kk = ks.getKieClasspathContainer();
		KieSession kieSession = kk.newKieSession("ksession-rules");
		
		// Rule listener
		kieSession.addEventListener(new RuleListener());
		
/*		DateFormat df = new SimpleDateFormat("dd.MM.yyyy hh:mm");
		Timer t1 = new Timer(df.parse("24.01.2018 8:00"), "");
		
		Product p1 = new Product("Mleko Imlek 1l", 100, ProductType.HLEB_MLEKO);
		Product p2 = new Product("Alkohol 1l", 1000, ProductType.ALKOHOL_CIGARETE);
		Product p3 = new Product("Telefon", 10000, ProductType.OSTALO);
		
		kieSession.insert(p1);
		kieSession.insert(p2);
		kieSession.insert(p3);
		
		kieSession.insert(t1);
		kieSession.fireAllRules();
		
		System.out.println(p1);
		System.out.println(p2);
		System.out.println(p3);
		System.out.println(t1.getDate() + " : " + t1.getMessage());
		Department it = new Department("IT");
		Department marketing = new Department("Marketing");
		Employee e1 = new Employee("Pera", true, it, "");
		Employee e2 = new Employee("Ivana", true, marketing, "");
		kieSession.insert(it);
		kieSession.insert(marketing);
		kieSession.insert(e1);
		kieSession.insert(e2);
		kieSession.fireAllRules();
*/
		KieSession kieSessionTables = kk.newKieSession("ksession-dtables");
		Customer c = new Customer("Ivana", "063123456", SubscriptionType.POSTPAID_PLAY, 5);
		kieSessionTables.insert(c);
		kieSessionTables.fireAllRules();
		System.out.println(c);
		
	}

}
