package rs.telenor.app.controller;

import org.kie.api.runtime.KieSession;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import rs.telenor.app.model.Customer;

@RequestMapping("customer")
@RestController
public class CustomerRestController {

    @Autowired
    private KieSession kieSession;

    @RequestMapping(value = "balance", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody
    Object checkBalance(@RequestBody Customer customer) {
        kieSession.insert(customer);
        kieSession.fireAllRules();
        return ResponseEntity.status(HttpStatus.OK).body(customer);
    }

}
